// cfpclass.h
// This file described the CfpClass class.

#ifndef INC_cfpclassh
#define INC_cfpclassh

#include "cfpinc.h"

//Not implemented in gcc yet (2.8.1)
//using namespace std;
//namespace Configpp{









//--------------------------------------------------------------------------------
//---- CfpClass ------------------------------------------------------------------
//--------------------------------------------------------------------------------
//: Holds information used to instantiate user objects

class CfpClass
{
  friend class CfpObject;
private:
  CfpFactory *factp;
  CfpObject *spawnerp;								// pointer to obj instantiator
  string name;									// name of the class
  string packagename;								// name of the package
private:
  map<string, CfpMemberVar *> argmanager;					// map version of var container
  map<string, CfpMemberVar *> varmanager;					// map version of var container
  map<string, CfpMemberFunc *> funcmanager;					// map version of func container
  set<string> isalist;								// list of types we match
public:
  CfpClass(CfpFactory *infactp,string inname,string inpackagename,CfpObject *inspawnerp);
public:
  CfpObject *makenew(string objname);						// make a new object
  void preinterpret() {spawnerp->preinterpret(this);};				// interp is starting
  void postinterpret()  {spawnerp->postinterpret(this);};			// interp is ending
public:
  string getname() {return name;};							// accessor
  string getpackagename() {return packagename;};					// accessor
  CfpObject *getspawner() {return spawnerp;};						// accessor
  CfpUnit *lookupUnit(string unitstring,bool throwerr=true);				// accessor
  CfpType *lookupType(string typestring,bool throwerr=true);				// accessor
  CfpMemberVar *lookup_membervar(string inname,bool throwerr=true);			// accessor
  CfpMemberVar *lookup_memberva(string inname,bool throwerr=true);			// accessor
  CfpMember *lookup_member(string inname,bool throwerr=true);				// accessor
  CfpMemberFunc *lookup_memberfunc(string inname,string argstr="",bool throwerr=true);	// accessor
  Configpp *getcfpp(){return factp->getcfpp();};						// accessor
public:
  string namehint(string name);								// return a hint about name
  bool isa(string typestr);								// is class a typestr?
public:
  CfpMemberFunc *addfunc(string inname,string argstring="",string retstring="",string inlabel="",string indesc="");
  CfpMemberFunc *addclassfunc(string inname,string argstring="",string retstring="",string inlabel="",string indesc="");


  CfpMemberVar *addarg(string inname,string ininitval="",bool insscope=false,string inlabel="",string unitstr="",string typestr="",string rangestr="",string indesc=""){return addarg(inname,CfpVal(ininitval,true),insscope,inlabel,unitstr,typestr,rangestr,indesc);};
  CfpMemberVar *addarg(string inname,CfpVal ininitval=CfpVal(),bool insscope=false,string inlabel="",string unitstr="",string typestr="",string rangestr="",string indesc="");

  CfpMemberVar *addvar(string inname,string ininitval="",bool insscope=false,string inlabel="",string unitstr="",string typestr="",string rangestr="",string indesc=""){return addvar(inname,CfpVal(ininitval,true),insscope,inlabel,unitstr,typestr,rangestr,indesc);};
  CfpMemberVar *addvar(string inname,CfpVal ininitval=CfpVal(),bool insscope=false,string inlabel="",string unitstr="",string typestr="",string rangestr="",string indesc="");


  CfpMemberVar *addvarg(string inname,int vecsize,string ininitval="",bool insscope=false,string inlabel="",string unitstr="",string typestr="",string rangestr="",string indesc=""){return addvarg(inname,vecsize,CfpVal(ininitval,true),insscope,inlabel,unitstr,typestr,rangestr,indesc);};
  CfpMemberVar *addvarg(string inname,int vecsize,CfpVal ininitval=CfpVal(),bool insscope=false,string inlabel="",string unitstr="",string typestr="",string rangestr="",string indesc="");

  CfpMemberVar *addvvar(string inname,int vecsize,string ininitval="",bool insscope=false,string inlabel="",string unitstr="",string typestr="",string rangestr="",string indesc=""){return addvvar(inname,vecsize,CfpVal(ininitval,true),insscope,inlabel,unitstr,typestr,rangestr,indesc);};
  CfpMemberVar *addvvar(string inname,int vecsize,CfpVal ininitval=CfpVal(),bool insscope=false,string inlabel="",string unitstr="",string typestr="",string rangestr="",string indesc="");


  CfpMemberFunc *addconstructor(string argstring="",string inkeyword="",string inlabel="",string indesc="");
public:
  void addisa(string newtypestr);							// add new type
  void permitchild(string typestr) {;};							// add alowable child
  void requirechild(string typestr) {;};						// add nesc. child
  void forbidchild(string typestr) {;};							// add forbidden child
  void permitparent(string typestr) {;};						// add alowable parent
  void requireparent(string typestr) {;};						// add required parent
  void forbidparent(string typestr) {;};						// add forbidden parent
};










//}
// Namespace close-brace
#endif
