//  Jesse Reichler, April 1996
//  Fred Delcomyn
//
//  experiment.C
//  This file contains the class methods for the Experiment class,
//   used to control and organize experiments, or simulation runs.
//  see .h file
//


#include "misc.def"
#include "misc.h"
#include "experiment.h"
#include "world.h"

#include <stdio.h>
#include <string.h>





Experiment:: Experiment(char *iname,World *inworldp,double runtime)
{
  // Begin construction of an experiment
  strcpy(name,iname);
  worldp=inworldp;
  stoptime=runtime;
}



Experiment:: ~Experiment()
{
  // The destructor: nothing for us to do.
}




void Experiment::iterate()
{
  // show on all cameras and get process important signals from
  //  the interactive viewer

  // has experiment ended?
  if (worldp->runtime>stoptime)
    end();

  // Iterate the world
  if (worldp->running)
    worldp->step();
  else
    ; // worldp->updatefordraw();
}


void Experiment::end()
{
  // Print some stats on the simulation run.
  // To get an accurate account of runing time, we first call fixupruntime()
  worldp->fixupruntime();
  
  printf("%f seconds simulated time.\n",(float)(worldp->worldtime));
  printf("%.0f seconds real running time.\n\n", (float)(worldp->runtime));
}

