// hexcon.C

#include "hexcon.h"





void Hexcon::buildcontroller()
{
  // allocate controllers for legs and set parameters (phases,etc.).
  float phases[3]={0,.5,0};
  int sidecount,legcount,linkcount;

  for (sidecount=0;sidecount<2;++sidecount)
    {
      for (legcount=0;legcount<3;++legcount)
	{
	  legcontrols[sidecount][legcount]=new HCleg();
	  legcontrols[sidecount][legcount]->setcycletime(cycletime);
	  if (sidecount==0)
	    legcontrols[sidecount][legcount]->setphase(phases[legcount]);
	  else
	    legcontrols[sidecount][legcount]->setphase(.5-phases[legcount]);
	}
    }

  for (sidecount=0;sidecount<2;++sidecount)
    {
      for (legcount=0;legcount<3;++legcount)
	{
	  //	  legcontrols[sidecount][legcount]->process(0);
	  //	  linkgoal[sidecount][legcount][0]=legcontrols[sidecount][legcount]->getgoal1();
	  //	  linkgoal[sidecount][legcount][1]=legcontrols[sidecount][legcount]->getgoal2();
	  //	  linkgoal[sidecount][legcount][2]=legcontrols[sidecount][legcount]->getgoal3();
	  linkstate[sidecount][legcount][0]=0;
	  linkstate[sidecount][legcount][1]=0;
	  linkstate[sidecount][legcount][2]=1.57;
	  linkgoal[sidecount][legcount][0]=0;
	  linkgoal[sidecount][legcount][1]=0;
	  linkgoal[sidecount][legcount][2]=1.57;
	}
    }

  // and reset everything
  for (sidecount=0;sidecount<2;++sidecount)
    {
      for (legcount=0;legcount<3;++legcount)
	{
	  for (linkcount=0;linkcount<3;++linkcount)
	    {
	      //	      linkstate[sidecount][legcount][linkcount]=1;
	      //	      linkgoal[sidecount][legcount][linkcount]=1;
	      //	      cout << "current goal is "<<linkgoal[sidecount][legcount][linkcount]<<".\n";
	    }
	}
    }
}






void Hexcon::setlegconstants()
{
  // tell all the leg controllers about the constants (cycletime, etc.)
  int sidecount,legcount;

  for (sidecount=0;sidecount<2;++sidecount)
    {
      for (legcount=0;legcount<3;++legcount)
	{
	  legcontrols[sidecount][legcount]->setcycletime(cycletime);
	  legcontrols[sidecount][legcount]->setrisetime(risetime);
	  legcontrols[sidecount][legcount]->setstabletime(stabletime);
	  legcontrols[sidecount][legcount]->setwalktime(walktime);
	}
    }
}





void Hexcon::process(float worldtime)
{
  // iterate the hexapod controller, one leg at a time
  //  (feed current joint angles to each leg controller, activate the leg controller, 
  //   then retrieve goals from leg controller and store locally).
  int sidecount,legcount;

  //  cout << "... IN HEXCON PROCESS!!\n";

  for (sidecount=0;sidecount<2;++sidecount)
    {
      for (legcount=0;legcount<3;++legcount)
	{
	  // set current input angles
	  legcontrols[sidecount][legcount]->setang1(linkstate[sidecount][legcount][0]);
	  legcontrols[sidecount][legcount]->setang2(linkstate[sidecount][legcount][1]);
	  legcontrols[sidecount][legcount]->setang3(linkstate[sidecount][legcount][2]);
	  // now iterate leg controller
	  legcontrols[sidecount][legcount]->process(worldtime);
	  // now get updated goals
	  linkgoal[sidecount][legcount][0]=legcontrols[sidecount][legcount]->getgoal1();
	  linkgoal[sidecount][legcount][1]=legcontrols[sidecount][legcount]->getgoal2();
	  linkgoal[sidecount][legcount][2]=legcontrols[sidecount][legcount]->getgoal3();
	  //	  printf("... leg[%d][%d] goals are %f, %f, %f.\n",sidecount,legcount,linkgoal[sidecount][legcount][0],linkgoal[sidecount][legcount][1],linkgoal[sidecount][legcount][2]);
	}
    }
}

































