// SWmovie_obj.C

#include "swmovie.h"





//--------------------------------------------------------------------------------
//---- SWmovie_obj::SWmovie_obj()
//--------------------------------------------------------------------------------

SWmovie_obj::SWmovie_obj(Configpp *cfpfp,CfpClass *inclassp,string oname)
  :CfpObject(cfpfp,inclassp,oname)
{
  // this is the constructor that gets called every time the user creates a new
  // instantiated object of the class. This function and makenew, the next, are partners.
  moviep=NULL;
}


//--------------------------------------------------------------------------------
//---- SWmovie_obj::makenew()
//--------------------------------------------------------------------------------

CfpObject *SWmovie_obj::makenew(CfpClass *inclassp,string objname)
{
  // create a new instance of ourselves, the wrapper.
  // Important: instantiating the wrapped class will come later (in function 'construct').

  return (new SWmovie_obj(configppp,inclassp,objname));
}







//--------------------------------------------------------------------------------
//---- SWmovie_obj()
//--------------------------------------------------------------------------------

void SWmovie_obj::registerwrappers(CfpFactory *sfactp)
{
  // this is the constructor that gets called ONCE when the class is registered with the factory.
  CfpClass *newclassp;

  newclassp=sfactp->registerclass("movie","Movie.Record",this);
  addargs_movie(newclassp);
  newclassp=sfactp->registerclass("movie","Movie.Play",this);
  addargs_movie(newclassp);

  // Register the movieobject class
  newclassp=sfactp->registerclass("movie","Movieobject",this);
  newclassp->addarg("obj","",false,"pointer to the cfpobject to save/load");
}








//--------------------------------------------------------------------------------
//---- SWmovie_obj::destruct()
//--------------------------------------------------------------------------------

void SWmovie_obj::destruct()
{
  // de-instantiate the wrapped object.
  if (baseclass()=="Movie" && moviep!=NULL)
    {
      // free the wrapped movie
      delete moviep;
    }

  instantiated=false;
}














//--------------------------------------------------------------------------------
//---- SWmovie_obj::construct() ------------------------------------------------
//--------------------------------------------------------------------------------

void SWmovie_obj::construct()
{
  // instantiate the wrapped object.  this is where we actually do late (lazy) instantiation.
  // if we are a wrapper for another class, we would allocate that target wrapped class here.
  // and save it to a local variable.  otherwise this is its own wrapper.
  // the args will have been filled by now.

  // create the wrapped object

  if (baseclass()=="Movie")
    construct_movie();
  if (baseclass()=="Movieobject")
    construct_movieobj();

  // add accessors
  addaccessors();

  // set the instantiated flag
  instantiated=true;
}


//--------------------------------------------------------------------------------
//---- SWmovie_obj::done()
//--------------------------------------------------------------------------------

CfpVal SWmovie_obj::done()
{
  // the object is done (ie no more children) return any return value

  if (baseclass()=="Movie")
    {
      if (subclass()=="Play")
	moviep->loadopen();
      else if (subclass()=="Record")
	moviep->saveopen();
    }
  else if (baseclass()=="Movieobject")
    {
      // add the movie object to the movie
      moviep->addobj(sobjp);
    }
  
  return retval;
}





//--------------------------------------------------------------------------------
//---- SWmovie_obj::construct_movie()
//--------------------------------------------------------------------------------

void SWmovie_obj::construct_movie()
{
  CfpVal val;
  string fname;
  string userdescription;

  // get name of file and user comments
  fname=(string)argval("filename");
  userdescription=(string)argval("description","");

  // create a new movie object
  localp=moviep=new cfpMovie(fname);
  moviep->setcomment(userdescription);

  // build a trigger to tell us when to update the sensor
  val=argval("triggersignal");
  updateacc=val.get_vaccesspointer();
  makelistener(updateacc,new CfpVFAMnotify<cfpMovie>("_update",this,moviep,&(cfpMovie::update)));
}



//--------------------------------------------------------------------------------
//---- SWmovie_obj::construct_movieobj()
//--------------------------------------------------------------------------------

void SWmovie_obj::construct_movieobj()
{
  CfpVal val;
  string fname;

  // get the parent movie
  moviep=(cfpMovie *)((configppp->parentinstantiate(this,"Movie",true))->getlocalp());
  
  // get the pointer to the movie object
  val=argval("obj");
  localp=sobjp=val.get_objectpointer();
}









//--------------------------------------------------------------------------------
//---- SWmovie_obj::addargs_movie()
//--------------------------------------------------------------------------------

void SWmovie_obj::addargs_movie(CfpClass *newclassp)
{
  // add the generic args for movie
  newclassp->addarg("filename","",false,"name of file to save or load from");
  newclassp->addarg("triggersignal","",false,"accessor for deciding when to update the movie)");
  newclassp->addarg("description","",false,"any user description of the movie - added to the file");
  newclassp->addvar("refreshrate","1",false,"how often to update the file");
}





//--------------------------------------------------------------------------------
//---- SWmovie_obj::addaccessors()
//--------------------------------------------------------------------------------

void SWmovie_obj::addaccessors()
{
  CfpVAccessor *varp;

  if (baseclass()=="Movie")
    {
      varp=addvar(new CfpVFAMsetval<cfpMovie,int,int>("refreshrate",this,moviep,&(moviep->setrate),&(moviep->getrate)));
    }
  else if (baseclass()=="Movieobject")
    {
    }
}

