// pdcontroller.C
// a proportional-derivitive controller class

// forward delcarations
class PDcontroller;

#ifndef pdcontrollerh_defined
#define pdcontrollerh_defined


class PDcontroller
{
public:
  PDcontroller();
public:
  void initialize();
  void process();
protected:
  float current,goal;
  float output;
  bool initialized;
  float pcomponent,dcomponent;
  float dist,lastdist,lastgoal;
private:
  float pconstant,dconstant;
  float maxout;
  float multiplier;
public:
  void setpconstant(float inpconstant){pconstant=inpconstant;};
  void setdconstant(float indconstant){dconstant=indconstant;};
  void setmaxout(float inmaxout){maxout=inmaxout;};
  void setgoal(float ingoal){goal=circlemod(ingoal);};
  void setcurrent(float incurrent){current=circlemod(incurrent);};
  void setmultiplier(float inm){multiplier=inm;};
public:
  float getpconstant(){return pconstant;};
  float getdconstant(){return dconstant;};
  float getmaxout(){return maxout;};
  float getgoal(){return goal;};
  float getcurrent(){return current;};
  float getoutput(){return output;};
  float getdist(){return dist;};
  float getpcomponent(){return pcomponent;};
  float getdcomponent(){return dcomponent;};
  float getmultiplier(){return multiplier;};
private:
  float circlemod(float radval);
};





#endif
