// swplot.h
// This file describes the wrappers for the main plot classes

// forward delcarations
class SWplot_obj;


#ifndef swploth_defined
#define swploth_defined

#include "cfpinc.h"
#include "plot.h"




class Pointval
{
private:
  int axisnum;
  CfpVAccessor *vac;
  float constval;
public:
  Pointval(int inaxisnum,CfpVAccessor *invac,float inconstval=0);
  int getaxisnum() {return axisnum;};
  float getval();
  //  float getval() {if (vac) {cout << vac->getname()<< "\n";return vac->get_float();} else return constval;};
};


//:Pointupdater is a helper class for SWplot_obj.
// it queries configpp objects and wraps data points, then calls the plot with a datapoint
class Pointupdater
{
private:
  int dims;
  Datapoint datap;
  list<Pointval *> pvals;
  list<Pointval *>::iterator pit;
public:
  Pointupdater() {dims=0;}
  ~Pointupdater() {;};
public:
  void update(Plot *plotp);						// update the wrapped plot
  void addpval(Pointval *pval);						// add a dimension (accessor)
  void complete();							// allocate space
};



class SWplot_obj: public CfpObject
{
private:
  Plot *plotp;
  PointSource *psourcep;
  VisibleAxis *axisp;
  Pointval *pval;
  Pointupdater *pup;
private:
  list<Pointupdater *>pups;						// list of pointupdaters
public:
  SWplot_obj(bool registerme=true):CfpObject() {if (registerme) GlobalFactoryreg(this,"Plot");};
  SWplot_obj(Configpp *cfpfp,CfpClass *inclassp,string oname);
public:
  virtual void registerwrappers(CfpFactory *sfactp);
  CfpObject *makenew(CfpClass *inclassp,string objname);		// generic makenew
  CfpVal done();							// any return value?
  void destruct();							// deinstatiate wrapped obj
  void construct();							// no arg constructor of wrappedobj
private:
  void construct_plot();						// build it
  void construct_axis();						// build it
  void construct_datapoint();						// build it
  void construct_axisval();						// build it
private:
  void addaccessors();							// add any variable accessors
  void addargs_plot(CfpClass *newclassp);				// add generic args
  void addargs_axis(CfpClass *newclassp);				// add generic args
public:
  void addpointup(Pointupdater *pup);					// add a datapoint
  void update();							// update the wrapped plot
};











#endif
