/*
=============================================================================
PROGRAM sneur.h = the sneur() functions header file
PURPOSE to generate spikes in a sensory neuron
VERSION 1998-08-28 revised 1998-09-15
PROGMER Jan Cocatre-Zilgien
LANGUAG C++ with Turbo C++ 3.0 under DOS 6.2
REMARKS works
=============================================================================
Modified to C++ by Jesse Reichler, 9/19/98
*/


class SNEUR
{
  friend class Configpp;
  friend class SWsneur;
private:
  //------ tags;
  //  char name[80];
  //  int version;
private:
  //------ primary parameters;
  double fmax;		//maximum firing frequency in Hz;
  double tau1;          //time constant for sensitivity to stimuland in s;
  double tau2;		//time constant for adaptation in s;
  double s2;		//minimum stimuland for tonic response;
  double sigma;		//tonic firing shape factor;
  double regu;		//from 0.0 (Poisson) to 1.0 (rigid pacemaker);
private:
  //------ variables;
  double deltat;        // deltat to use if not specified explicitly
  double f;				//current frequency in Hz;
  double oldS;			//last value of stimuland;
  double elapsed;		//time since last spike in s;
  
  // new vars;
  double frate;
  double spikecount;
public:
  SNEUR();
  SNEUR(double infmax,double intau1,double intau2,double s2,double sigma,double regu);
  ~SNEUR();
public:
  void initialize();
  void defaults();
  void setparams(double infmax,double intau1,double intau2,double s2,double sigma,double regu);
  void setdeltat(double indeltat) {deltat=indeltat;};
public:
  double spikes(double stimuland, double dt);
  double spikes(double stimuland) {return spikes(stimuland,deltat);};
private:
  void reset();
};


