// cfptype.h
// This file described the cfptype related classes, like units and user typedefs

#ifndef INC_cfptypeh
#define INC_cfptypeh

#include "cfpinc.h"

//Not implemented in gcc yet (2.8.1)
//using namespace std;
//namespace Configpp{







//--------------------------------------------------------------------------------
//---- CfpUnit -------------------------------------------------------------------
//--------------------------------------------------------------------------------
//: Holds a description of a unit measurement.
// Used to restrict variable values and convert between them.

class CfpUnit
{
private:
  class CfpFactory *factp;							// pointer to the factory
  string name;									// name of units (ie meters)
  string basetypename;								// base unit type (ie length)
  string singularname;								// name of singular form (meter)
public:
  CfpUnit() {factp=NULL;name="";basetypename="";};
  CfpUnit(CfpFactory *infactp, string inname, string inbase="", string insingular="");
public:
  string getname() {return name;};
  string prettyname() {return name;};
};




//--------------------------------------------------------------------------------
//---- CfpType -------------------------------------------------------------------
//--------------------------------------------------------------------------------
//: Base class for user variable types

class CfpType
{
private:
  CfpFactory *factp;							// pointer to factory
  string name;								// name of the type
public:
  CfpType(CfpFactory *infactp, string inname);
public:
  string getname(){return name;};
};













//}
// Namespace close-brace
#endif
