// cfpval.C

#include "cfpinc.h"

//Not implemented in gcc yet (2.8.1)
//using namespace std;
//namespace Configpp{



extern Configpp *globalconfigppp;







//--------------------------------------------------------------------------------
//---- CfpVal::CfpVal() ----------------------------------------------------------
//--------------------------------------------------------------------------------

CfpVal::CfpVal()
{
  // initialize the value type
  valtype=undefinedVType;
  veclength=0;
  accessindex=-1;
}



//--------------------------------------------------------------------------------
//---- CfpVal::CfpVal() ----------------------------------------------------------
//--------------------------------------------------------------------------------

CfpVal::CfpVal(string instring,bool condef)
{
  // initialize the value type
  if (condef)
    {
      if  (instring=="")
	{
	  // shorthand for saying it's undefined.  this is used by functions like addarg, which get passed
	  //  a string to be used to created a CfpVal, and they want to use an empty string to mean undefined
	  valtype=undefinedVType;
	  return;
	}
      else if (instring==" ")
	instring="";
      else if (instring=="  ")
	instring=" ";
    }
  stringset(instring);
}




//--------------------------------------------------------------------------------
//---- CfpVal::CfpVal() ----------------------------------------------------------
//--------------------------------------------------------------------------------

void CfpVal::stringset(string instring)
{
  // we should smartly convert the string to whatever type we are
  valtype=stringVType;
  stringval=instring;
}





//--------------------------------------------------------------------------------
//---- CfpVal::convertin()
//--------------------------------------------------------------------------------

void CfpVal::convertin(char *val)
{
  // depending on our current type, interpret the char string passed
  switch (valtype)
    {
    case boolVType:
      if (val==NULL)
	boolval=false;
      else if (val[0]=='\0')
	boolval;
      else
	boolval=true;
      break;
    case stringVType:
      stringval=string(val);
      break;
    case numberVType:
      numberval=strtod(val,NULL);
      break;
    default:
      throw CfpError("attempt to convert in a value '"+string(val)+"' which can't be converted.","",syntactical,false,true,&sloc);
      break;
    }
}






//--------------------------------------------------------------------------------
//---- CfpVal::set_number() ------------------------------------------------------
//--------------------------------------------------------------------------------

void CfpVal::set_number(string stringnum)
{
  // convert string to a number and call regular set_number()
  set_number(strtod(stringnum.c_str(),NULL));
}



//--------------------------------------------------------------------------------
//---- CfpVal::maketype() --------------------------------------------------------
//--------------------------------------------------------------------------------

void CfpVal::maketype(CfpValType expectedtype)
{
  // convert to type or throw error if you can't
  string ftypestr,ttypestr;
  char *errp;

  ftypestr=typestr();
  ttypestr=typestr(expectedtype);
  //  cout << "Inside a maketype from " << ftypestr<< " to " << ttypestr << ".\n";
  
  if (valtype==vaccesspointerVType && expectedtype!=vaccesspointerVType)
    {
      // evaluate the accessor in order to convert it.
      // here we actually convert the current cfpval into the accessors value, and then continue
      *this=vaccesspointer->get(accessindex);
    }

  if (valtype==undefinedVType)
    throw CfpError("attempt to access a value which is currently undefined.","",syntactical,false,true,&sloc);

  switch (expectedtype)
    {
    case boolVType:
      if (valtype==numberVType)
	{
	  if (numberval!=0)
	    boolval=true;
	  else
	    boolval=false;
	  valtype=boolVType;
	}
      else if (valtype==stringVType)
	{
	  if (stringval!="false" && stringval!="")
	    boolval=true;
	  else
	    boolval=false;
	  valtype=boolVType;
	}
      break;
    case stringVType:
      if (valtype==numberVType)
	{
	  stringval=JRdtostr(numberval);
	  valtype=stringVType;
	}
      else if (valtype==boolVType)
	{
	  if (boolval==false)
	    stringval="FALSE";
	  else
	    stringval="TRUE";
	  valtype=stringVType;
	}
      break;
    case numberVType:
      if (valtype==stringVType)
	{
	  numberval=strtod(stringval.c_str(),&errp);
	  if (*errp!='\0')
	    {
	      // error trying to convert
	      ftypestr=typestr();
	      ttypestr=typestr(expectedtype);
	      throw CfpError("there was an error trying to convert value '"+stringval+"' from "+ftypestr+" type to "+ttypestr+" type.","",syntactical,false,true,&sloc);
	    }
	  valtype=numberVType;
	}
      else if (valtype==boolVType)
	{
	  if (boolval==false)
	    numberval=0;
	  else
	    numberval=1;
	  valtype=numberVType;
	}
      break;
    case vaccesspointerVType:
      if (valtype==stringVType)
	{
	  // the current value is a string, and user has requested an accessor.
	  // what we would like to do now is lookup the string as if we were parsing it and get an accessor
	  // (ie like lazy instantiatin).
	  // We had to create a global pointer to do this, oh well it lastet so long without one.
	  vaccesspointer=globalconfigppp->findvaccessor(stringval,accessindex);
	  if (vaccesspointer!=NULL)
	    {
	      // success, it was found!
	      valtype=vaccesspointerVType;
	    }
	}
      break;
    }


  if (valtype!=expectedtype)
    {
      ftypestr=typestr();
      ttypestr=typestr(expectedtype);
      cout << "ERROR: value cannot be converted from "+ftypestr+" type to "+ttypestr+" type.\n";
      throw CfpError("value cannot be converted from "+ftypestr+" type to "+ttypestr+" type.","",syntactical,false,true,&sloc);
    }
}





//--------------------------------------------------------------------------------
//---- CfpVal::typestr() ---------------------------------------------------------
//--------------------------------------------------------------------------------

string CfpVal::typestr(CfpValType vtype,CfpUnit *unitp)
{
  // return a string describing the value type
  string tstring="";

  // first get basic type
  switch(vtype)
    {
    case undefinedVType:
      tstring+="undefined";
      break;
    case boolVType:
      tstring+="bool";
      break;
    case stringVType:
      tstring+="string";
      break;
    case numberVType:
      tstring+="number";
      break;
    case voidpointerVType:
      tstring+="(void pointer)";
      break;
    case classpointerVType:
      tstring+="(class pointer)";
      break;
    case objectpointerVType:
      tstring+="(object pointer)";
      break;
    case vaccesspointerVType:
      tstring+="(variable access pointer)";
      break;
    default:
      throw CfpError("unknown value type.","",internal,true,(Configpp *)NULL);
    }
  
  // now add units
  if (unitp!=NULL)
    {
      if (unitp->getname()!="")
	tstring+=" ("+unitp->getname()+")";
    }

  return tstring;
}




//--------------------------------------------------------------------------------
//---- CfpVal::isdefined() -------------------------------------------------------
//--------------------------------------------------------------------------------

bool CfpVal::isdefined()
{
  // if val is defined then return true
  if (valtype!=undefinedVType)
    return true;
  return false;
}



//--------------------------------------------------------------------------------
//---- CfpVal::print()
//--------------------------------------------------------------------------------

void CfpVal::print()
{
  // print some debug friendly info
  cout << "typestr=" << typestr() << ".\n";
}


bool CfpVal::operator!=(CfpVal v2)
{
  // decide whether the two are unequal
  return true;
}






//}
// Namespace close-brace


