/***********************************************************************

 DMatrix.h
 DMatrix Class
 Copyright (C) 1993
        Lyle Hall 1993/94
        Eric C. Welton 1993/94
        Beckman Institute - Urbana, Illinois
        For Neuronal Pattern Analysis Group and Hexapod Project

        These libraries are free and may be redistributed and/or modified,
        provided the above notice and this paragraph are included.
        These libraries may not be sold and are distributed without
        any warranty or implication of fitness for a purpose.

 General Information

        The DMatrix library provides fundamental matrix-of-double
 operations.

***********************************************************************/

#ifndef DMATRIX_HDR 
#define DMATRIX_HDR 

#define __DONT_DEFINE_MATRIX_TEMPLATE
#define TYPE         double
#define VCLASSNAME   DVector
#define MCLASSNAME   DMatrix

// If we haven't included the DVector header file (and thus
// declared the DVector class) we must forward reference
// the DVector class.
#ifndef DVECTOR_HDR
class DVector;
#endif

// next we have to make sure that the MatrixT.h header gets
// included
#ifdef MATRIX_HDR
#undef MATRIX_HDR
#endif
#include <MatrixT.h>

#ifdef INLINE_MATRIX_CODE
#include <Matrix_Imp.h>
#endif

#undef __DONT_DEFINE_MATRIX_TEMPLATE
#undef TYPE
#undef VCLASSNAME
#undef MCLASSNAME

#endif
