/***********************************************************************

 DVector.h
 DVector Class Header File
 Copyright (C) 1993
        Lyle Hall 1993/94
        Eric C. Welton 1993/94
        Beckman Institute - Urbana, Illinois
        For Neuronal Pattern Analysis Group and Hexapod Project

        These libraries are free and may be redistributed and/or modified,
        provided the above notice and this paragraph are included.
        These libraries may not be sold and are distributed without
        any warranty or implication of fitness for a purpose.

 General Information

        The DVector library provides fundamental vector-of-double
 operations.

***********************************************************************/

#ifndef DVECTOR_HDR 
#define DVECTOR_HDR 

#define __DONT_DEFINE_VECTOR_TEMPLATE
#define TYPE         double
#define VCLASSNAME   DVector
#define MCLASSNAME   DMatrix

// If we haven't included the DMatrix header file (and thus
// declared the DMatrix class) we must forward reference
// the DMatrix class.
#ifndef DMATRIX_HDR
class DMatrix;
#endif

// next we have to make sure that the VectorT.h header gets
// included
#ifdef VECTOR_HDR
#undef VECTOR_HDR
#endif
#include <VectorT.h>

#undef __DONT_DEFINE_VECTOR_TEMPLATE
#undef TYPE
#undef VCLASSNAME
#undef MCLASSNAME

#endif
