/***********************************************************************

 FMatrix.h
 FMatrix Class
 Copyright (C) 1993
        Lyle Hall 1993/94
        Eric C. Welton 1993/94
        Beckman Institute - Urbana, Illinois
        For Neuronal Pattern Analysis Group and Hexapod Project

        These libraries are free and may be redistributed and/or modified,
        provided the above notice and this paragraph are included.
        These libraries may not be sold and are distributed without
        any warranty or implication of fitness for a purpose.

 General Information

        The FMatrix library provides fundamental matrix-of-float
 operations.

***********************************************************************/

#ifndef FMATRIX_HDR 
#define FMATRIX_HDR 

#define __DONT_DEFINE_MATRIX_TEMPLATE
#define TYPE         float
#define VCLASSNAME   FVector
#define MCLASSNAME   FMatrix

// If we haven't included the FVector header file (and thus
// declared the FVector class) we must forward reference
// the FVector class.
#ifndef FVECTOR_HDR
class FVector;
#endif

// next we have to make sure that the MatrixT.h header gets
// included
#ifdef MATRIX_HDR
#undef MATRIX_HDR
#endif
#include <MatrixT.h>

#undef __DONT_DEFINE_MATRIX_TEMPLATE
#undef TYPE
#undef VCLASSNAME
#undef MCLASSNAME

#endif
