/***********************************************************************

 ProjectionMatrix.c
 Projection Matrix - a Camera type viewing matrix - source code
 Copyright (C) 1993
        Eric C. Welton 1993/94
        Beckman Institute - Urbana, Illinois
        For Neuronal Pattern Analysis Group and Hexapod Project

        These libraries are free and may be redistributed and/or modified,
        provided the above notice and this paragraph are included.
        These libraries may not be sold and are distributed without
        any warranty or implication of fitness for a purpose.


***********************************************************************/

#include "ProjectionMatrix.h"
#include "TransformationMatrix.h"

void CameraDHP32::Set() {

 fill(0.0);

 DVectorHR3     n;
 DVectorHR3     v;
 n=(ref-eye).normalize();
 n.normalize_self();
 v=up-((up.dot(n))*n.normalize());
 v.normalize_self();

 DVectorHR3     u=n.cross(v);
 u.normalize_self();

 (*this).replace_row(0,u);
 (*this).replace_row(1,v);
 (*this).replace_row(2,n);

 double r1=-1.0*ref.dot(u);
 double r2=-1.0*ref.dot(v);
 double r3=-1.0*ref.dot(n);
 (*this)(3,3)=1.0;
 (*this)=(*this)*TranslationDMatrixHR3(r1,r2,r3);
 }

void CameraFHP32::Set() {

 fill(0.0);

 FVectorHR3     n;
 FVectorHR3     v;
 n=(ref-eye).normalize();
 n.normalize_self();
 v=up-((up.dot(n))*n.normalize());
 v.normalize_self();

 FVectorHR3     u=n.cross(v);
 u.normalize_self();

 (*this).replace_row(0,u);
 (*this).replace_row(1,v);
 (*this).replace_row(2,n);

 float r1=-1.0*ref.dot(u);
 float r2=-1.0*ref.dot(v);
 float r3=-1.0*ref.dot(n);
 (*this)(3,3)=1.0;
 (*this)=(*this)*TranslationFMatrixHR3(r1,r2,r3);
 }

