// JRgrobsymbols.h
// Grob enumerations, etc.

#ifndef INC_JRgrobsymbolsh
#define INC_JRgrobsymbolsh

//Not implemented in gcc yet (2.8.1)
//using namespace std;
//namespace Grob{




// ----------------------------------------------------------------------------------
// NOTE: if we want to be nice, we support the idea that we #ifdef all references to
//       graphics libraries like open gl, so that this class can be compiled on
//       machines that don't have all the libs it supports.
#define GrobGL
#undef GrobFLTK
#undef GrobPOV



// ----------------------------------------------------------------------------------
// GrobDetail - enumerations for drawing detail
// ----------------------------------------------------------------------------------
//: self explanatory except for 'paintdetail' which has detail between high and fine,
//   but should have no material color settings

#define GROBDETAILS 5
typedef enum GrobDetail
{
  lowdetail=0,
  meddetail,
  highdetail,
  finedetail,
  paintdetail
};

typedef enum GrobProjectionMode
{
  perspective=0,
  orthogonal
};

typedef enum GrobTicktype
{
  notick,
  linetick,
  squaretick,
  boxtick
};

#define GROBCOLORSCALES 9
typedef enum GrobColorScaleType
{
  colorless_scale,
  hot_scale,
  cool_scale,
  jet_scale,
  hsv_scale,
  pink_scale,
  bone_scale,
  copper_scale,
  gray_scale
};


typedef enum GrobSpacerType
{
  none_spacer,
  xy_spacer,
  z_spacer,
  box_spacer,
};



// ----------------------------------------------------------------------------------
// Some maths we need
// ----------------------------------------------------------------------------------

#define DEG2RAD 0.017453292
#define RAD2DEG 57.29578122
#ifndef M_PI
#define M_PI	3.1415926535
#endif
#ifndef M_PI2
#define M_PI2	(M_PI/2.0)
#endif







// }
// Namespace close-brace
#endif
