// JRmat.C

#include "JRmat.h"

//Not implemented in gcc yet (2.8.1)
//using namespace std;
//namespace JR{





void JRmathelper::Normalize(perVectorR3 &vec)
{
  // normalize a 3vector
  double len;

  len=sqrt(vec(0)*vec(0)+vec(1)*vec(1)+vec(2)*vec(2));
  vec(0)=vec(0)/len;
  vec(1)=vec(1)/len;
  vec(2)=vec(2)/len;
}


perVectorR3 JRmathelper::Cross(perVectorR3 a, perVectorR3 b)
{
  // Our replacement for Matrix alg. inefficient but cfpe crossproduct of 2 3dvectors
  perVectorR3 c;
  
  c(0)=(a(1)*b(2))-(a(2)*b(1));
  c(1)=(a(2)*b(0))-(a(0)*b(2));
  c(2)=(a(0)*b(1))-(a(1)*b(0));
  
  return c;
}



perMatrix JRmathelper::ConvertEuler(double e1,double e2,double e3,perMatrix &R)
{
  // Convert euler angles to a transformational matrix
  //  this is used in base computeDeAb() and camera update_after_draw()

  // compute the body to earth transform
  double ce1,ce2,ce3;
  double se1,se2,se3;

  // compute some shorthands
  ce1=cos(e1); ce2=cos(e2); ce3=cos(e3);
  se1=sin(e1); se2=sin(e2); se3=sin(e3);

  // okay compute DeAb;
  R(0,0)=ce1*ce2;
  R(0,1)=ce1*se2*se3-se1*ce3;
  R(0,2)=ce3*se2*ce1+se1*se3;
  R(1,0)=se1*ce2;
  R(1,1)=se1*se2*se3+ce1*ce3;
  R(1,2)=se1*se2*ce3-ce1*se3;
  R(2,0)=-se2;
  R(2,1)=ce2*se3;
  R(2,2)=ce2*ce3;

  return R;
}







// }
// Namespace close-brace
